3 # Some things for you to configure
12 # Where you want to install the tools
13 if [ "${1}" = "" ]; then
14 echo "Syntax: ${0} </installation/target/directory> [download & build directory (default ${PWD})]"
20 # Where do you want to build the tools. This is where the log files
21 # will be written (which you can monitor with 'tail' during compilation).
22 # You can delete this directory after everything is done.
23 if [ ! "${2}" = "" ]; then
28 BUILDDIR
=${SRCDIR}/build-gnuarm4
30 # Where to get each of the toolchain components
31 BINUTILS
=http
://ftp.gnu.org
/gnu
/binutils
/binutils-
${BINUTILS_VER}.
tar.bz2
32 BINUTILS_TAR
=binutils-
${BINUTILS_VER}.
tar.bz2
33 GCCCORE
=http
://ftp.gnu.org
/gnu
/gcc
/gcc-
${GCC_VER}/gcc-core-
${GCC_VER}.
tar.bz2
34 GCCCORE_TAR
=gcc-core-
${GCC_VER}.
tar.bz2
35 GPP
=http
://ftp.gnu.org
/gnu
/gcc
/gcc-
${GCC_VER}/gcc-g
++-${GCC_VER}.
tar.bz2
36 GPP_TAR
=gcc-g
++-${GCC_VER}.
tar.bz2
37 NEWLIB
=ftp://sources.redhat.com
/pub
/newlib
/newlib-
${NEWLIB_VER}.
tar.gz
38 NEWLIB_TAR
=newlib-
${NEWLIB_VER}.
tar.gz
39 #INSIGHT=ftp://sourceware.org/pub/insight/releases/insight-${INSIGHT_VER}.tar.bz2
40 INSIGHT
=http
://mirrors.kernel.org
/sources.redhat.com
/insight
/releases
/insight-
${INSIGHT_VER}.
tar.bz2
41 INSIGHT_TAR
=insight-
${INSIGHT_VER}.
tar.bz2
42 #INSIGHT=http://www.mirrorservice.org/sites/sources.redhat.com/pub/insight/releases/insight-${INSIGHT_VER}.tar.bz2
43 GDB
=http
://ftp.gnu.org
/gnu
/gdb
/gdb-
${GDB_VER}.
tar.bz2
44 GDB_TAR
=gdb-
${GDB_VER}.
tar.bz2
45 GMP
=http
://ftp.sunet.se
/pub
/gnu
/gmp
/gmp-
${GMP_VER}.
tar.bz2
46 GMP_TAR
=gmp-
${GMP_VER}.
tar.bz2
47 MPFR
=http
://ftp.gnu.org
/gnu
/mpfr
/mpfr-
${MPFR_VER}.
tar.bz2
48 MPFR_TAR
=mpfr-
${MPFR_VER}.
tar.bz2
49 GNU_KEYRING_GPG
=gnu-keyring.gpg
50 GNU_KEYRING
=ftp://ftp.gnu.org
/gnu
/${GNU_KEYRING_GPG}
52 # Common configuration options (i.e., things to pass to 'configure')
53 COMMON_CFG
="--enable-interwork --target=arm-eabi --program-prefix=arm-none-eabi- --prefix=${DESTDIR} --disable-werror --enable-languages=c,c++ --enable-multilib --disable-shared"
55 # Extra configuration options for each toolchain component
57 GCCCORE_CFG
="--disable-nls --disable-threads --with-gcc --with-gnu-ld --with-gnu-as --with-dwarf2 --with-newlib --with-headers=${BUILDDIR}/newlib-${NEWLIB_VER}/newlib/libc/include --disable-libssp --disable-libstdcxx-pch --disable-libmudflap --disable-libgomp -v"
66 # -nv: non-verbose but not too quiet (still print errors/warnings)
67 # -nc: no-clobber, do not download a file that already exists
68 # -t 0: retry indefinitely
69 # -a wget.log: append errors/warnings to wget.log file
71 #WGET_OPTS="-nv -nc -t 0 -a wget.log"
74 # Compiler flags for compiling Newlib (-O2 is already hard-coded)
75 NEWLIB_FLAGS
="-march=armv4t -mcpu=arm7tdmi -g"
77 # GPG options to avoid polluting the user's keyring
78 GPG_OPTS
="--keyring ${GNU_KEYRING_GPG} --no-default-keyring --homedir ."
80 ############################################################################
81 # End of configuration section. You shouldn't have to modify anything below.
82 ############################################################################
84 if [[ "$USER" != "root" ]]; then
85 echo "*** Warning! Not running as root!"
86 echo "Installation may fail if you do not have appropriate permissions!"
92 if [[ -f all.downloaded
]]; then
93 echo Looks like all downloads are complete
, skipping downloads
95 wget
${WGET_OPTS} ${GNU_KEYRING}
97 # TODO: guess it's better to have a function that "downloads, checks file-presence and signature, and returns true/false" whether the file is ok
98 # Function will check if file exists (otherwise try to download the file - if failed and file still doesn't exist, complain and exit the script)
99 # Check if signature file exists (otherwise download the signature file as well - if download fail, warn the user and return function)
100 # Check the signature. If failed, backup-by-renaming current files, redownload both file & signature, run the function body one more time - if still no success, warn and return from function
102 function download_lib
{
103 echo Now downloading
$1
107 function download_signed_lib
{
109 wget
-N ${WGET_OPTS} $2.sig
110 gpg
$GPG_OPTS --verify $3.sig
2> /dev
/null
111 if [[ $?
!= 0 ]]; then
112 echo "Failed signature check for:" $3.sig
117 # NOTE: If new downloads are added here, please see the IMPORTANT note below
118 download_signed_lib BINUTILS
${BINUTILS} ${BINUTILS_TAR} ||
exit 1
119 download_signed_lib GCC
${GCCCORE} ${GCCCORE_TAR} ||
exit 1
120 download_signed_lib G
++ ${GPP} ${GPP_TAR} ||
exit 1
121 download_lib NEWLIB
${NEWLIB}
122 # TODO: signature/hash check
123 download_lib INSIGHT
${INSIGHT}
124 # TODO: signature/hash check
125 download_signed_lib GDB
${GDB} ${GDB_TAR} ||
exit 1
126 download_signed_lib GMP
${GMP} ${GMP_TAR} ||
exit 1
127 download_signed_lib MPFR
${MPFR} ${MPFR_TAR} ||
exit 1
129 # IMPORTANT: Here is the number of .tar. archives downloaded above. Please update if new .tar. are added to download list.
130 if [[ `ls -1 *.tar.bz2 *.tar.gz | wc -l` != 8 ]]; then
131 echo "Seems like not all prerequisite files downloaded... Exiting."
139 if [[ -f binutils.built
]]; then
140 echo Looks like BINUTILS was already built.
142 echo Building BINUTILS...
143 tar -xjf ..
/`basename ${BINUTILS}`
144 echo ___________________
> make.log
145 echo Building binutils...
>> make.log
146 cd `find . -maxdepth 1 -type d -name 'binutils*'`
149 ..
/configure
${COMMON_CFG} ${BINUTILS_CFG} >> ..
/..
/make.log
2>&1
150 make ${MAKEFLAGS} MAKEINFO
=`which makeinfo` >> ..
/..
/make.log
2>&1
151 make install >> ..
/..
/make.log
2>&1
156 echo ___________________
>> make.log
157 echo Adding
${DESTDIR}/bin to PATH
>> make.log
158 export PATH
; PATH
=${DESTDIR}/bin
:$PATH
159 echo ___________________
>> make.log
161 if [[ -f gcc.built
]]; then
162 echo Looks like GCC was already built.
165 tar -xjf ..
/`basename ${GCCCORE}`
166 tar -xjf ..
/`basename ${GPP}`
167 tar -xjf ..
/`basename ${GMP}`
168 ln -s "${BUILDDIR}/gmp-${GMP_VER}" "${BUILDDIR}/gcc-${GCC_VER}/gmp"
169 tar -xjf ..
/`basename ${MPFR}`
170 ln -s "${BUILDDIR}/mpfr-${MPFR_VER}" "${BUILDDIR}/gcc-${GCC_VER}/mpfr"
171 tar -xzf ..
/`basename ${NEWLIB}`
173 echo ___________________
>> make.log
175 cat << EOF > gcc.patch
176 --- gcc-4.3.3.orig/gcc/config/arm/t-arm-elf
177 +++ gcc-4.3.3.mod/gcc/config/arm/t-arm-elf
179 # MULTILIB_DIRNAMES += fpu soft
180 # MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
182 -# MULTILIB_OPTIONS += mno-thumb-interwork/mthumb-interwork
183 -# MULTILIB_DIRNAMES += normal interwork
184 +MULTILIB_OPTIONS += mno-thumb-interwork/mthumb-interwork
185 +MULTILIB_DIRNAMES += normal interwork
187 # MULTILIB_OPTIONS += fno-leading-underscore/fleading-underscore
188 # MULTILIB_DIRNAMES += elf under
191 echo Patching GCC
>> make.log
192 cd `find . -maxdepth 1 -type d -name 'gcc*'`
193 patch -p1 < ..
/gcc.
patch
194 echo Building gcc...
>> make.log
197 ..
/configure
${COMMON_CFG} ${GCCCORE_CFG} >> ..
/..
/make.log
2>&1
198 make ${MAKEFLAGS} all-gcc
>> ..
/..
/make.log
2>&1
199 make install >> ..
/..
/make.log
2>&1
204 if [[ -f newlib.built
]]; then
205 echo Looks like NEWLIB was already built.
207 echo Building NEWLIB...
208 echo ___________________
>> make.log
209 echo Building newlib...
>> make.log
210 cd `find . -maxdepth 1 -type d -name 'newlib*'`
213 ..
/configure
${COMMON_CFG} ${NEWLIB_CFG} >> ..
/..
/make.log
2>&1
215 # This line adds our NEWLIB_CFLAGS to the configure.host file in the
216 # newlib subdirectory. This is the only way I could find to tell Newlib to
217 # compile itself with the -mmarch=armv4t and -mcpu=arm7tdmi flags.
218 # sed -i "/^newlib_cflags=/s/=.*\$/=\"${NEWLIB_FLAGS}\"/" ../newlib/configure.host
219 make ${MAKEFLAGS} >> ..
/..
/make.log
2>&1
220 make install >> ..
/..
/make.log
2>&1
225 echo ___________________
>> make.log
226 echo "Now that newlib is built, second pass for GCC..." >> make.log
227 cd `find . -maxdepth 1 -type d -name 'gcc*'`
229 make ${MAKEFLAGS} >> ..
/..
/make.log
2>&1
230 make install >> ..
/..
/make.log
2>&1
234 if [[ -f insight.built
]]; then
235 echo Looks like INSIGHT was already built.
237 echo Building INSIGHT...
238 tar -xjf ..
/`basename ${INSIGHT}`
239 echo ___________________
>> make.log
240 echo Building insight...
>> make.log
241 cd `find . -maxdepth 1 -type d -name 'insight*'`
244 ..
/configure
${COMMON_CFG} ${INSIGHT_CFG} >> ..
/..
/make.log
2>&1
245 make ${MAKEFLAGS} >> ..
/..
/make.log
2>&1
246 make install >> ..
/..
/make.log
2>&1
251 if [[ -f gdb.built
]]; then
252 echo Looks like GDB was already built.
255 tar -xjf ..
/`basename ${GDB}`
256 echo ___________________
>> make.log
257 echo Building insight...
>> make.log
258 cd `find . -maxdepth 1 -type d -name 'gdb*'`
261 ..
/configure
${COMMON_CFG} ${GDB_CFG} >> ..
/..
/make.log
2>&1
262 make ${MAKEFLAGS} >> ..
/..
/make.log
2>&1
263 make install >> ..
/..
/make.log
2>&1
268 echo ___________________
>> make.log
269 echo Build complete.
>> make.log
274 echo Downloaded archives are
in ${SRCDIR}
275 echo build driectory
: ${BUILDDIR}
276 echo set environment variable ARMLIB to
${DESTDIR}/lib
/gcc
/arm-eabi
/4.3.3/interwork
for Makefile.linux